#include <sys/thread.h>
#include <sys/heap.h>
#include "httpinfo.h"

int ShowThreads(FILE * stream)
{
	NUTTHREADINFO *tdp = nutThreadList;
	const char *states[] = { "TRM",
		"<FONT COLOR=#CC0000>RUN</FONT>",
		"<FONT COLOR=#339966>RDY</FONT>",
		"SLP"
	};

	static prog_char head_P[] = "<HTML><HEAD><TITLE>Nut/OS Threads</TITLE>"
		"</HEAD><BODY><h1>Nut/OS Threads</h1>\r\n" "HeapAvailable:%d\r\n";
	static prog_char ttop_P[] = "<TABLE BORDER><TR><TH>Handle</TH>"
		"<TH>Name</TH><TH>Priority</TH>"
		"<TH>Status</TH><TH>Event<BR>Queue</TH>"
		"<TH>Timer</TH><TH>Stack-<BR>pointer</TH>" "<TH>Free<BR>Stack</TH></TR>\r\n";
	static prog_char tbot_P[] = "</TABLE></BODY></HTML>";
	static prog_char tfmt_P[] = "<TR><TD>%04X</TD><TD>%s</TD><TD>%u</TD>"
		"<TD>%s</TD><TD>%04X</TD><TD>%04X</TD>"
		"<TD>%04X</TD><TD>%u</TD><TD>%s</TD></TR>\r\n";

	fprintf_P(stream, head_P, NutHeapAvailable());

	fputs_P(ttop_P, stream);
	while (tdp)
	{
		fprintf_P(stream, tfmt_P, tdp, tdp->td_name, tdp->td_priority,
				  states[tdp->td_state], tdp->td_queue, tdp->td_timer,
				  tdp->td_sp,
				  (u_short) tdp->td_sp - (u_short) tdp->td_memory,
				  *((u_long *) tdp->td_memory) != DEADBEEF ? "Corr" : "OK");
		tdp = tdp->td_next;
	}
	fputs_P(tbot_P, stream);

	return 0;
}
