

#include <stdio.h>
#include <sys/thread.h>
#include <sys/timer.h>
#include <sys/heap.h>
#include <io.h>
//#include <sys/uart.h> // UART_SETSPEED

#include "globdef.h"

#include "eeparams/eeparams.h"				// contains gBoarddata structure
#include "setup/setup.h"

#include "utilities.h"

#define MAIN_VARS
#include "main.h"
#include "http/httpd.h"
#include "spi_flash/file_sys.h"


#define	SETUP_MASK  0x80					//PB7 - setup select pin
u_char  SetupJumper = 0;



void main(void)
{
	outb(DDRB, inb(DDRB) & ~SETUP_MASK);	// only setup is input
	outb(PORTB, inb(PORTB) | SETUP_MASK);	// pull up .. = 1


	SetupJumper = ~inb(PINB) & SETUP_MASK;	// used in eeprom_load

	stdout = stdin = uart0 = InitUart0(9600);

	if (flash_InitFileSys())
		return;								// file system init

	//load setup parameters from EEPROM (1 -> force seeding with defaults from eeprom.c)
	eeprom_load(0 /*1 */ );

	if (SetupJumper)
		Setup(uart0);						/* after setup continue with standard application */

	EthernetInit();

	HttpInit();

	for (;;)
	{
		NutSleep(5000);
	}
}
