
#include <sys/types.h>
#include <sys/timer.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <stdio.h>
#include <io.h>
#include <dev/uartavr.h>
#include <sys/heap.h>
#include <net/route.h>
#include <avr/wdt.h>
#include "dump.h"

#include "utilities.h"
#include "eeparams/eeparams.h"


#include <sys/socket.h>
#include <dev/nicrtl.h>
//#include <pro/dhcp.h>
#include <arpa/inet.h>


#define MAX_BUF_LEN     256
char   *tmpbuf;

#ifdef LANLOG

//static u_long addr_target;
static UDPSOCKET *syslog_sock;
#endif

#ifdef COMMLOG
static FILE *suart;
#endif


#if defined(LANLOG) || defined(COMMLOG)
////////////////////////////////////////////////////////////////////////////
void LogSendBuff(u_char * buff, int len)
{
#ifdef LANLOG
	int     n, count;
	static int flag;						//prevent looping

	if (syslog_sock)
	{
		n = 0;
		while (1)
		{
			count = min(len - n, 1024);
			///         if (NutUdpSendTo(syslog_sock, addr_target, SYSLOG_PORT, buff + n, count) == -1)
			if (NutUdpSendTo
				(syslog_sock, *(u_long *) & gBoardDatap->SnmpTraps[0].ip, SYSLOG_PORT,
				 buff + n, count) == -1)
			{
				if (!flag)
				{
					flag = 1;
					LOG_MSG("Error while sending SYSLOG (HEAP: %d) ", NutHeapAvailable());
					flag = 0;
				}
				break;
			}


			if ((n += count) >= len)
				break;
		}
	}

#endif
#ifdef COMMLOG
	if (suart)
	{
		/*
		 * _write can send output to a specific stream.
		 * If printf or puts or similar fn is needed
		 * than uart should be freopen()ed for stdout.
		 */
		_write(_fileno(suart), buff, len);
		fflush(suart);
	}
#endif
}

////////////////////////////////////////////////////////////////////////////
void LogSend(const prog_char * format, ...)
{
	//Jirko: ten buffer ma 256 bytu a bere se to ze zasobniku (to se nedela bu,bu,bu)
	//  char tmpbuf[MAX_BUF_LEN];
	va_list arg_ptr;
	va_start(arg_ptr, format);
	vsprintf_P(tmpbuf, format, arg_ptr);
	va_end(arg_ptr);

	LogSendBuff(tmpbuf, strlen(tmpbuf));
}

////////////////////////////////////////////////////////////////////////////
#ifdef LANLOG
void UdpSyslogInit(void)
{
	syslog_sock = NutUdpCreateSocket(SYSLOG_PORT);
	//addr_target = inet_addr(ADDR_TARGET);

#ifndef COMMLOG
	tmpbuf = (char *)NutHeapAlloc(MAX_BUF_LEN);
#endif
}
#endif

////////////////////////////////////////////////////////////////////////////
#ifdef COMMLOG
void CommSyslogInit(FILE * uart)
{
	tmpbuf = (char *)NutHeapAlloc(MAX_BUF_LEN);

#if 1										//DF 20.10.2003
	stdout = stdin = suart = uart;
#else
	u_long  baud = 9600 /*115200 */ ;		//just to have same speed on both ports
	//u_long cooked_mode = 0;   //zakaze prepisovani \r na \r\n

#ifdef LOG_UART0
	NutRegisterDevice(&devUart0, 0, 0);
	suart = freopen("uart0", "w", stdout);
#else
	NutRegisterDevice(&devUart1, 0, 0);
	suart = freopen("uart1", "w", stdout);
#endif
	_ioctl(_fileno(suart), UART_SETSPEED, &baud);
	//_ioctl(_fileno(suart), UART_SETCOOKEDMODE, &cooked_mode);
#endif
}
#endif

#endif										//defined(LANLOG) || defined(COMMLOG)

////////////////////////////////////////////////////////////////////////////
FILE   *InitUart0(u_long baud)
{
	FILE   *uart;

	//u_long cooked_mode = 0;   //zakaze prepisovani \n na \r\n

#ifdef LOG_UART0
	NutRegisterDevice(&devUart1, 0, 0);
	uart = fopen("uart1", "r+b" /*"b" */ );
#else
	NutRegisterDevice(&devUart0, 0, 0);
	uart = fopen("uart0", "r+b");			//select binary mode
#endif
	_ioctl(_fileno(uart), UART_SETSPEED, &baud);
	//following is set automatically when binary mode is selected
	//_ioctl(_fileno(uart), UART_SETCOOKEDMODE, &cooked_mode);

	return uart;
}

////////////////////////////////////////////////////////////////////////////
FILE   *InitUart1(u_long baud)
{
	FILE   *uart;

	//u_long cooked_mode = 0;   //zakaze prepisovani \n na \r\n

	NutRegisterDevice(&devUart1, 0, 0);
	uart = fopen("uart1", "r+b");
	_ioctl(_fileno(uart), UART_SETSPEED, &baud);
	//following is set automatically when binary mode is selected
	//_ioctl(_fileno(uart), UART_SETCOOKEDMODE, &cooked_mode);

	return uart;
}

/*
 * This function is API for XML parser. It is called when baudrate is set.
 * If uart1 is not used DO NOT use second line -> system lock up.
 */
void UART_setSpeed(u_long * baudratep)
{
	extern FILE *uart0;
	//  extern FILE *uart1;

	_ioctl(_fileno(uart0), UART_SETSPEED, baudratep);
#if 0										//DF 12.2.2004 - !!! not used during development
	_ioctl(_fileno(uart1), UART_SETSPEED, baudratep);
#endif
}

////////////////////////////////////////////////////////////////////////////
void EthernetInit(void)
{
	NutRegisterDevice(&devEth0, 0x8300, 5);

	//  if (NutDhcpIfConfig("eth0", 0, 5000))
	{
		//    u_char mac[] = { 0x00,0x0A,0x59,0x03,0x00,0x34 };

		u_long  ip_addr = *(u_long *) & my_ip_addr;
		u_long  ip_mask = *(u_long *) & my_ip_mask;
		u_long  gw_addr = *(u_long *) & gw_ip_addr;
#if 0										//tady to nejak nechodilo (mozna, ze ted uz to bude chodit)
		LOG_MSG("IP:  %s\n", inet_ntoa(ip_addr));
		LOG_MSG("mask:%s\n", inet_ntoa(ip_mask));
		LOG_MSG("MAC: %02X-%02X-%02X-%02X-%02X-%02X", my_eth_addr.eth_addr[0],
				my_eth_addr.eth_addr[1], my_eth_addr.eth_addr[2], my_eth_addr.eth_addr[3],
				my_eth_addr.eth_addr[4], my_eth_addr.eth_addr[5]);
#endif
		NutNetIfConfig("eth0", my_eth_addr.eth_addr /*mac */ , ip_addr, ip_mask);

		if (gw_addr)
			NutIpRouteAdd(0, 0, gw_addr, &devEth0);
	}

}

#ifdef HTTP_DEBUG
////////////////////////////////////////////////////////////////////////////
int ShowSockets(void)
{
	extern TCPSOCKET *tcpSocketList;
	TCPSOCKET *ts;

	static prog_char state_0_P[] = "CLOSED";
	static prog_char state_1_P[] = "LISTEN";
	static prog_char state_2_P[] = "SYNSENT";
	static prog_char state_3_P[] = "SYNRCVD";
	static prog_char state_4_P[] = "ESTABL";
	static prog_char state_5_P[] = "CLOSEWAIT";
	static prog_char state_6_P[] = "FINWAIT1";
	static prog_char state_7_P[] = "CLOSING";
	static prog_char state_8_P[] = "LASTACK";
	static prog_char state_9_P[] = "FINWAIT2";
	static prog_char state10_P[] = "TIMEWAIT";
	/*state has to reside in .data as normal array operation is done on it,
	 * puts_P() then gets a pointer into .progmem section (flash)
	 */
	static prog_char *state[] = {
		state_0_P,
		state_1_P,
		state_2_P,
		state_3_P,
		state_4_P,
		state_5_P,
		state_6_P,
		state_7_P,
		state_8_P,
		state_9_P,
		state10_P
	};
	static prog_char state_unk_P[] = "?UNK?";

	LOG_MSG("\n\rHandle\tType\tLocal\t\tRemote\t\tStatus\n");

	for (ts = tcpSocketList; ts; ts = ts->so_next)
	{
		LOG_MSG("\n\r%04X\tTCP\t%s:%u\t", ts, inet_ntoa(ts->so_local_addr),
				ntohs(ts->so_local_port));
		LOG_MSG("\n\r%s:%u\t", inet_ntoa(ts->so_remote_addr), ntohs(ts->so_remote_port));

		LOG_MSG2(ts->so_state > TCPS_TIME_WAIT ? state_unk_P : state[ts->so_state]);
	}

	return 0;
}
#endif

#if 0										//currently not used
////////////////////////////////////////////////////////////////////////////
void ViewEeprom(u_short count)
{
	char   *buf;

	buf = (char *)NutHeapAlloc(count);
	if (!buf)
	{
		LOG_MSG("\r\nLow Mem (ViewEeprom)");
		return;
	}
	LOG_MSG("\n\nEEPROM contents:\n");
	eeprom_read_block(buf, (void *)0, count);
	dump_char(buf, count);

	NutHeapFree(buf);
}
#endif

void unit_reboot(void)
{
	cli();
	wdt_reset();
	wdt_enable(1);
	while (1);
}

void mem_dump(FILE * myuart, unsigned char *buff, unsigned int length)
{
	unsigned char dumpstr[17];
	unsigned char cnt = 0;

	dumpstr[16] = 0;
	fprintf(myuart, "\n\r");
	while (length--)
	{
		if (*buff >= 0x20)
			dumpstr[cnt] = *buff;
		else
			dumpstr[cnt] = '.';
		fprintf(myuart, "%02X ", *buff++);
		if (cnt++ >= 15)
		{
			fprintf(myuart, "    %s\n\r", dumpstr);
			cnt = 0;
		}
	}

	if (cnt > 0)
	{
		dumpstr[cnt] = 0;
		while (cnt++ <= 16)
			fprintf(myuart, "   ");
		fprintf(myuart, " %s\n\r", dumpstr);
	}
}

u_char hexTochar(u_char * buf)
{
	int     i;
	u_char  tempchar;
	u_char  result = 0;

	for (i = 1; i >= 0; i--)
	{
		tempchar = *(buf++);
		if ((tempchar >= '0') && (tempchar <= '9'))
		{
			result |= (tempchar - '0');
		}
		else
		{
			tempchar &= ~0x20;
			if ((tempchar >= 'A') && (tempchar <= 'F'))
			{
				result |= (tempchar - 'A' + 10);
			}
		}
		result <<= (4 * i);

	}
	return result;
}
