
#include <stdio.h>
#include <sys/types.h>

#include "globdef.h"						//COMMLOG, LANLOG
#include "eeparams/eeparams.h"				//AccessS

#define max(a, b)	((a) > (b) ? (a) : (b))
#define min(a, b)	((a) > (b) ? (b) : (a))


FILE   *InitUart0(u_long baud);
FILE   *InitUart1(u_long baud);
void    UART_setSpeed(u_long * baudratep);
void    EthernetInit(void);

#if defined(LANLOG) || defined(COMMLOG)
void    CommSyslogInit(FILE * uart);
void    UdpSyslogInit(void);

void    LogSend(const prog_char * format, ...);	//max 256 bytu !!!!!
void    LogSendBuff(u_char * buff, int len);

#define LOG_MSG(format, ...)	LogSend(PSTR(format), ## __VA_ARGS__)
#define LOG_MSG2(format, ...)	LogSend(format, ## __VA_ARGS__)
#define LOG_MSG_HEX(hex, len)   LogSendHex(hex, len)
#define LOG_MSG_BUF(buf, len)   LogSendBuff(buf, len)
#else
#define LOG_MSG(format, ...)
#define LOG_MSG2(format, ...)
#define LOG_MSG_HEX(hex, len)
#define LOG_MSG_BUF(buf, len)
#endif


int     ShowSockets(void);
void    ViewEeprom(u_short count);

void    unit_reboot(void);

void    mem_dump(FILE * myuart, unsigned char *buff, unsigned int length);
u_char  hexTochar(u_char * chr);
